From 4ed0da064df7df08a5a5ad5d716c9e58133f6b88 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Fri, 23 Sep 2016 17:23:08 -0400
Subject: [PATCH 12/44] FIXME: Introduce class function_reader (v3)

FIXME: move some fns into rtx_reader
FIXME: Introduce rtx_reader::read_rtx_operand
* rtx_reader::read_rtx_code: rename 'i' to 'idx' and use 'c' rathen than 'i' for result of read_skip_spaces
* rtx_reader::read_rtx_operand:
  * make locals more tightly-scoped (tmp-wide, m, str, start, end, ptr, tmpstr)
  * rename 'i' to 'idx'
FIXME: split base_rtx_reader out from rtx_reader; move maybe_read_location into rtx_reader
FIXME: add function_reader::read_rtx_operand and move various stuff to function_reader

FIXME: Introduce class function_reader (v2)

FIXME: ChangeLog needs updating

Changed in v2:
* eliminate m_tempfile from rtl_dump_test, moving dumps out into
separate files, using selftest::locate_file
* add selftest::location to rtl_dump_test
* move various "wart" parsing from read-rtl.c to read-rtl-function.c

This patch generalizes the RTL-reading capabilities so that they
can be run on the host as well as the build machine.
The available rtx in rtl.def changes dramatically between these
two configurations, so a fair amount of #ifdef GENERATOR_FILE is
required to express this.

This patch introduces a function_reader subclass of rtx_reader,
capable of reading an RTL function dump (or part of one),
reconstructing a cfun with a CFG and basic blocks containing insns.

gcc/ChangeLog:
	* Makefile.in (OBJS): Add errors.o, read-md.o, read-rtl.o,
	read-rtl-function.o, and selftest-rtl.o.
	* cfgexpand.c (pass_expand::execute): Move stack initializations
	to rtl_data::init_stack_alignment and call it.  Pass "true"
	for new "emit_insns" param of expand_function_start.
	* emit-rtl.c (gen_reg_rtx): Move regno_pointer_align and
	regno_reg_rtx resizing logic to...
	(emit_status::ensure_regno_capacity): ...this new method.
	(init_emit): Allocate regno_reg_rtx using ggc_cleared_vec_alloc
	rather than ggc_vec_alloc.
	(rtl_data::init_stack_alignment): New method.
	(get_insn_by_uid): New function.
	* emit-rtl.h (rtl_data::init_stack_alignment): New method.
	* errors.c: Use consistent pattern for bconfig.h vs config.h
	includes.
	(progname): Wrap with #ifdef GENERATOR_FILE.
	(error): Likewise.  Add "error: " to message.
	(fatal): Likewise.
	(internal_error): Likewise.
	(trim_filename): Likewise.
	(fancy_abort): Likewise.
	* errors.h (struct file_location): Move here from read-md.h.
	(file_location::file_location): Likewise.
	(error_at): New decl.
	* function-tests.c (selftest::verify_three_block_rtl_cfg): Remove
	"static".
	* function.c (instantiate_decls): Guard call to
	instantiate_decls_1 with if (DECL_INITIAL (fndecl)).
	(expand_function_start): Add param "emit_insns", and use it to
	guard the various gen/emit calls.
	* function.h (emit_status::ensure_regno_capacity): New method.
	(expand_function_start): Add bool param to decl.
	* gensupport.c (gen_reader::gen_reader): Add NULL for new policy
	param of rtx_reader ctor.
	* print-rtl.c (print_rtx): Print "(nil)" rather than an empty
	string for NULL strings.  Print "(nil)" for NULL basic blocks.
	* read-md.c (read_skip_construct): Provide forward decl.
	(read_skip_spaces): Support '/'.
	(require_char): New function.
	(require_word_ws): New function.
	(peek_char): New function.
	(read_name): Rename to...
	(read_name_1): ...this new static function, adding "out_loc" param,
	and converting "missing name or number" to returning false, rather
	than failing.
	(read_name): Reimplement in terms of read_name_1.
	(read_name_or_nil): New function.
	(read_string): Handle "(nil)" by returning NULL.  */
	(rtx_reader::rtx_reader): Add rtl_reader_policy * param, using
	it to initialize m_policy.
	(rtx_reader::~rtx_reader): Free m_base_dir.  Clean up global data.
	* read-md.h (struct file_location): Move to errors.h.
	(file_location::file_location): Likewise.
	Include errors.h.
	(class regno_remapper): New class.
	(struct rtl_reader_policy): New struct.
	(rtx_reader::rtx_reader): Add rtl_reader_policy * param.
	(rtx_reader::add_fixup_insn_uid): New vfunc.
	(rtx_reader::add_fixup_bb): New vfunc.
	(rtx_reader::add_fixup_note_insn_basic_block): New vfunc.
	(rtx_reader::add_fixup_source_location): New vfunc.
	(rtx_reader::add_fixup_jump_label): New vfunc.
	(rtx_reader::add_fixup_expr): New vfunc.
	(rtx_reader::remap_regno): New method.
	(rtx_reader::m_policy): New field.
	(noop_reader::noop_reader): Add NULL for new policy param of
	rtx_reader ctor.
	(peek_char): New decl.
	(require_char): New decl.
	(require_word_ws): New decl.
	(read_name): Convert return type from void to file_location.
	(read_name_or_nil): New decl.
	* read-rtl-function.c: New file.
	* read-rtl-function.h: New file.
	* read-rtl.c: Potentially include config.h rather than bconfig.h.
	For host, include function.h and emit-rtl.h.
	(apply_subst_iterator): Wrap with #ifdef GENERATOR_FILE.
	(bind_subst_iter_and_attr): Likewise.
	(add_condition_to_string): Likewise.
	(add_condition_to_rtx): Likewise.
	(apply_attribute_uses): Likewise.
	(add_current_iterators): Likewise.
	(apply_iterators): Likewise.
	(initialize_iterators): Guard usage of apply_subst_iterator with
	#ifdef GENERATOR_FILE.
	(read_conditions): Wrap with #ifdef GENERATOR_FILE.
	(read_mapping): Likewise.
	(add_define_attr_for_define_subst): Likewise.
	(add_define_subst_attr): Likewise.
	(read_subst_mapping): Likewise.
	(check_code_iterator): Likewise.
	(read_rtx): Likewise.  Move one-time initialization logic to...
	(one_time_initialization): New function.
	(parse_reg_note_name): New function.
	(parse_note_insn_name): New function.
	(maybe_read_location): New function.
	(read_until): New function.
	(strip_trailing_whitespace): New function.
	(read_flags): New function.
	(regno_remapper::get_effective_regno): New method.
	(rtx_reader::remap_regno): New method.
	(read_rtx_code): Remove "static".  Initialize "iterator" to NULL.
	Call one_time_initialization.  Wrap iterator lookup within
	#ifdef GENERATOR_FILE.  Add parsing support for RTL dumps,
	mirroring the special-cases in print_rtx, by calling
	read_flags, reading SYMBOL_REF data, REG_NOTE names,
	INSN_UID values, note-specific data, basic block IDs,
	jump labels, hexdump values of wide ints, REG_EXPR, MEM_EXPR,
	skipping recognized insn names, remapping register numbers.
	When on host, reallocate XSTR and XTMPL fields in the GC-managed
	heap.
	(lookup_global_register): New function.
	(consolidate_reg): New function.
	(consolidate_singletons): New function.
	(read_nested_rtx): Call consolidate_singletons.
	* rtl.h (read_rtx): Wrap decl with #ifdef GENERATOR_FILE.
	(read_rtx_code): New decl.
	* selftest-rtl.c: New file.
	* selftest-rtl.h: New file.
	* selftest-run-tests.c (selftest::run_tests): Run
	read_rtl_function_c_tests.
	* selftest.h  (selftest::read_rtl_function_c_tests): New decl.
	* tree-dfa.c (ssa_default_def): Return NULL_TREE for rtl function
	dumps.
---
 gcc/Makefile.in                                    |    5 +
 gcc/emit-rtl.c                                     |   13 +
 gcc/errors.c                                       |   23 +-
 gcc/errors.h                                       |   13 +
 gcc/function-tests.c                               |    2 +-
 gcc/function.c                                     |    3 +-
 gcc/genpreds.c                                     |    6 +-
 gcc/print-rtl.c                                    |    4 +-
 gcc/read-md.c                                      |  112 +-
 gcc/read-md.h                                      |   70 +-
 gcc/read-rtl-function.c                            | 1739 ++++++++++++++++++++
 gcc/read-rtl-function.h                            |   56 +
 gcc/read-rtl.c                                     |  244 ++-
 gcc/rtl.h                                          |    4 +
 gcc/selftest-rtl.c                                 |   78 +
 gcc/selftest-rtl.h                                 |   65 +
 gcc/selftest-run-tests.c                           |    1 +
 gcc/selftest.h                                     |    1 +
 gcc/testsuite/selftests/asr_div1.rtl               |   19 +
 gcc/testsuite/selftests/const-int.rtl              |   12 +
 .../selftests/copy-hard-reg-into-frame.rtl         |    8 +
 gcc/testsuite/selftests/example-labels.rtl         |    2 +
 gcc/testsuite/selftests/insn-with-mode.rtl         |    1 +
 gcc/testsuite/selftests/jump-to-label-ref.rtl      |    6 +
 gcc/testsuite/selftests/jump-to-return.rtl         |    6 +
 gcc/testsuite/selftests/jump-to-simple-return.rtl  |    6 +
 gcc/testsuite/selftests/note-insn-deleted.rtl      |    1 +
 gcc/testsuite/selftests/note_insn_basic_block.rtl  |    1 +
 gcc/testsuite/selftests/symbol-ref.rtl             |    3 +
 gcc/tree-dfa.c                                     |    5 +
 30 files changed, 2413 insertions(+), 96 deletions(-)
 create mode 100644 gcc/read-rtl-function.c
 create mode 100644 gcc/read-rtl-function.h
 create mode 100644 gcc/selftest-rtl.c
 create mode 100644 gcc/selftest-rtl.h
 create mode 100644 gcc/testsuite/selftests/asr_div1.rtl
 create mode 100644 gcc/testsuite/selftests/const-int.rtl
 create mode 100644 gcc/testsuite/selftests/copy-hard-reg-into-frame.rtl
 create mode 100644 gcc/testsuite/selftests/example-labels.rtl
 create mode 100644 gcc/testsuite/selftests/insn-with-mode.rtl
 create mode 100644 gcc/testsuite/selftests/jump-to-label-ref.rtl
 create mode 100644 gcc/testsuite/selftests/jump-to-return.rtl
 create mode 100644 gcc/testsuite/selftests/jump-to-simple-return.rtl
 create mode 100644 gcc/testsuite/selftests/note-insn-deleted.rtl
 create mode 100644 gcc/testsuite/selftests/note_insn_basic_block.rtl
 create mode 100644 gcc/testsuite/selftests/symbol-ref.rtl

diff --git a/gcc/emit-rtl.c b/gcc/emit-rtl.c
index 12bdbb0..2383f95 100644
--- a/gcc/emit-rtl.c
+++ b/gcc/emit-rtl.c
@@ -6304,5 +6304,18 @@ rtl_data::init_stack_alignment ()
   preferred_stack_boundary = STACK_BOUNDARY;
 }
 
+/* Get the insn with the given uid, or NULL if not found.  */
+
+rtx_insn *
+get_insn_by_uid (int uid)
+{
+  for (rtx_insn *insn = get_insns (); insn; insn = NEXT_INSN (insn))
+    if (INSN_UID (insn) == uid)
+      return insn;
+
+  /* Not found.  */
+  return NULL;
+}
+
 
 #include "gt-emit-rtl.h"
diff --git a/gcc/errors.c b/gcc/errors.c
index 468384c..8df94ab 100644
--- a/gcc/errors.c
+++ b/gcc/errors.c
@@ -21,18 +21,21 @@ along with GCC; see the file COPYING3.  If not see
    in the generator programs; the compiler has a more elaborate suite
    of diagnostic printers, found in diagnostic.c.  */
 
-#ifdef HOST_GENERATOR_FILE
-#include "config.h"
-#define GENERATOR_FILE 1
-#else
+/* This file is compiled twice: once for the generator programs
+   once for the compiler.  */
+#ifdef GENERATOR_FILE
 #include "bconfig.h"
+#else
+#include "config.h"
 #endif
 #include "system.h"
 #include "errors.h"
 
 /* Set this to argv[0] at the beginning of main.  */
 
+#ifdef GENERATOR_FILE
 const char *progname;
+#endif /* #ifdef GENERATOR_FILE */
 
 /* Starts out 0, set to 1 if error is called.  */
 
@@ -55,13 +58,15 @@ warning (const char *format, ...)
 
 /* Print an error message - we keep going but the output is unusable.  */
 
+#ifdef GENERATOR_FILE
+
 void
 error (const char *format, ...)
 {
   va_list ap;
 
   va_start (ap, format);
-  fprintf (stderr, "%s: ", progname);
+  fprintf (stderr, "%s: error: ", progname);
   vfprintf (stderr, format, ap);
   va_end (ap);
   fputc ('\n', stderr);
@@ -69,6 +74,7 @@ error (const char *format, ...)
   have_error = 1;
 }
 
+#endif /* #ifdef GENERATOR_FILE */
 
 /* Fatal error - terminate execution immediately.  Does not return.  */
 
@@ -78,7 +84,7 @@ fatal (const char *format, ...)
   va_list ap;
 
   va_start (ap, format);
-  fprintf (stderr, "%s: ", progname);
+  fprintf (stderr, "%s: error: ", progname);
   vfprintf (stderr, format, ap);
   va_end (ap);
   fputc ('\n', stderr);
@@ -87,6 +93,8 @@ fatal (const char *format, ...)
 
 /* Similar, but say we got an internal error.  */
 
+#ifdef GENERATOR_FILE
+
 void
 internal_error (const char *format, ...)
 {
@@ -127,8 +135,11 @@ trim_filename (const char *name)
 /* "Fancy" abort.  Reports where in the compiler someone gave up.
    This file is used only by build programs, so we're not as polite as
    the version in diagnostic.c.  */
+
 void
 fancy_abort (const char *file, int line, const char *func)
 {
   internal_error ("abort in %s, at %s:%d", func, trim_filename (file), line);
 }
+
+#endif /* #ifdef GENERATOR_FILE */
diff --git a/gcc/errors.h b/gcc/errors.h
index a6973f3..c63f06b 100644
--- a/gcc/errors.h
+++ b/gcc/errors.h
@@ -28,8 +28,21 @@ along with GCC; see the file COPYING3.  If not see
 #ifndef GCC_ERRORS_H
 #define GCC_ERRORS_H
 
+/* Records a position in the file.  */
+struct file_location {
+  file_location () {}
+  file_location (const char *, int);
+
+  const char *filename;
+  int lineno;
+};
+
+inline file_location::file_location (const char *filename_in, int lineno_in)
+  : filename (filename_in), lineno (lineno_in) {}
+
 extern void warning (const char *, ...) ATTRIBUTE_PRINTF_1 ATTRIBUTE_COLD;
 extern void error (const char *, ...) ATTRIBUTE_PRINTF_1 ATTRIBUTE_COLD;
+extern void error_at (file_location, const char *, ...) ATTRIBUTE_PRINTF_2 ATTRIBUTE_COLD;
 extern void fatal (const char *, ...) ATTRIBUTE_NORETURN ATTRIBUTE_PRINTF_1 ATTRIBUTE_COLD;
 extern void internal_error (const char *, ...) ATTRIBUTE_NORETURN ATTRIBUTE_PRINTF_1 ATTRIBUTE_COLD;
 extern const char *trim_filename (const char *);
diff --git a/gcc/function-tests.c b/gcc/function-tests.c
index 4152cd3..2235b4c 100644
--- a/gcc/function-tests.c
+++ b/gcc/function-tests.c
@@ -420,7 +420,7 @@ verify_three_block_gimple_cfg (function *fun)
 
 /* As above, but additionally verify the RTL insns are sane.  */
 
-static void
+void
 verify_three_block_rtl_cfg (function *fun)
 {
   verify_three_block_cfg (fun);
diff --git a/gcc/function.c b/gcc/function.c
index 24a1ce1..4c67b52 100644
--- a/gcc/function.c
+++ b/gcc/function.c
@@ -1901,7 +1901,8 @@ instantiate_decls (tree fndecl)
     instantiate_decl_rtl (DECL_RTL (DECL_VALUE_EXPR (decl)));
 
   /* Now process all variables defined in the function or its subblocks.  */
-  instantiate_decls_1 (DECL_INITIAL (fndecl));
+  if (DECL_INITIAL (fndecl))
+    instantiate_decls_1 (DECL_INITIAL (fndecl));
 
   FOR_EACH_LOCAL_DECL (cfun, ix, decl)
     if (DECL_RTL_SET_P (decl))
diff --git a/gcc/genpreds.c b/gcc/genpreds.c
index 6db1b7b..a9092da 100644
--- a/gcc/genpreds.c
+++ b/gcc/genpreds.c
@@ -1205,7 +1205,7 @@ write_tm_constrs_h (void)
   printf ("\
 /* Generated automatically by the program '%s'\n\
    from the machine description file '%s'.  */\n\n", progname,
-	  rtx_reader_ptr->get_top_level_filename ());
+	  base_rtx_reader_ptr->get_top_level_filename ());
 
   puts ("\
 #ifndef GCC_TM_CONSTRS_H\n\
@@ -1405,7 +1405,7 @@ write_tm_preds_h (void)
   printf ("\
 /* Generated automatically by the program '%s'\n\
    from the machine description file '%s'.  */\n\n", progname,
-	  rtx_reader_ptr->get_top_level_filename ());
+	  base_rtx_reader_ptr->get_top_level_filename ());
 
   puts ("\
 #ifndef GCC_TM_PREDS_H\n\
@@ -1555,7 +1555,7 @@ write_insn_preds_c (void)
   printf ("\
 /* Generated automatically by the program '%s'\n\
    from the machine description file '%s'.  */\n\n", progname,
-	  rtx_reader_ptr->get_top_level_filename ());
+	  base_rtx_reader_ptr->get_top_level_filename ());
 
   puts ("\
 #include \"config.h\"\n\
diff --git a/gcc/print-rtl.c b/gcc/print-rtl.c
index a905127..a2cb69a 100644
--- a/gcc/print-rtl.c
+++ b/gcc/print-rtl.c
@@ -220,7 +220,7 @@ print_rtx (const_rtx in_rtx)
       string:
 
 	if (str == 0)
-	  fputs (" \"\"", outfile);
+	  fputs (" (nil)", outfile);
 	else
 	  fprintf (outfile, " (\"%s\")", str);
 	sawclose = 1;
@@ -586,6 +586,8 @@ print_rtx (const_rtx in_rtx)
 #ifndef GENERATOR_FILE
 	if (XBBDEF (in_rtx, i))
 	  fprintf (outfile, " %i", XBBDEF (in_rtx, i)->index);
+	else
+	  fprintf (outfile, " (nil)");
 #endif
 	break;
 
diff --git a/gcc/read-md.c b/gcc/read-md.c
index 495a8a6..4e5ec16 100644
--- a/gcc/read-md.c
+++ b/gcc/read-md.c
@@ -56,7 +56,7 @@ void (*include_callback) (const char *);
 
 /* Global singleton.  */
 
-rtx_reader *rtx_reader_ptr;
+base_rtx_reader *base_rtx_reader_ptr;
 
 /* A table of md_constant structures, hashed by name.  Null if no
    constant expansion should occur.  */
@@ -65,6 +65,8 @@ static htab_t md_constants;
 /* A table of enum_type structures, hashed by name.  */
 static htab_t enum_types;
 
+static void read_skip_construct (int depth, file_location loc);
+
 /* Given an object that starts with a char * name field, return a hash
    code for its name.  */
 
@@ -274,8 +276,8 @@ fatal_with_file_and_line (const char *msg, ...)
 
   va_start (ap, msg);
 
-  fprintf (stderr, "%s:%d: error: ", rtx_reader_ptr->get_filename (),
-	   rtx_reader_ptr->get_lineno ());
+  fprintf (stderr, "%s:%d: error: ", base_rtx_reader_ptr->get_filename (),
+	   base_rtx_reader_ptr->get_lineno ());
   vfprintf (stderr, msg, ap);
   putc ('\n', stderr);
 
@@ -295,8 +297,8 @@ fatal_with_file_and_line (const char *msg, ...)
   context[i] = '\0';
 
   fprintf (stderr, "%s:%d: note: following context is `%s'\n",
-	   rtx_reader_ptr->get_filename (), rtx_reader_ptr->get_lineno (),
-	   context);
+	   base_rtx_reader_ptr->get_filename (),
+	   base_rtx_reader_ptr->get_lineno (), context);
 
   va_end (ap);
   exit (1);
@@ -345,7 +347,7 @@ read_skip_spaces (void)
 	    if (c != '*')
 	      {
 		unread_char (c);
-		fatal_with_file_and_line ("stray '/' in file");
+		return '/';
 	      }
 
 	    prevc = 0;
@@ -399,7 +401,7 @@ void require_word_ws (const char *expected)
 /* Read the next character from the file.  */
 
 int
-rtx_reader::read_char (void)
+base_rtx_reader::read_char (void)
 {
   int ch;
 
@@ -413,7 +415,7 @@ rtx_reader::read_char (void)
 /* Put back CH, which was the last character read from the file.  */
 
 void
-rtx_reader::unread_char (int ch)
+base_rtx_reader::unread_char (int ch)
 {
   if (ch == '\n')
     m_read_md_lineno--;
@@ -433,8 +435,8 @@ peek_char (void)
 /* Read an rtx code name into NAME.  It is terminated by any of the
    punctuation chars of rtx printed syntax.  */
 
-void
-read_name (struct md_name *name)
+static bool
+read_name_1 (struct md_name *name, file_location *out_loc)
 {
   int c;
   size_t i;
@@ -472,8 +474,12 @@ read_name (struct md_name *name)
       c = read_char ();
     }
 
+  unread_char (c);
+  *out_loc = base_rtx_reader_ptr->get_current_location ();
+  read_char ();
+
   if (i == 0)
-    fatal_with_file_and_line ("missing name or number");
+    return false;
 
   name->buffer[i] = 0;
   name->string = name->buffer;
@@ -494,6 +500,36 @@ read_name (struct md_name *name)
 	}
       while (def);
     }
+
+  return true;
+}
+
+/* Read an rtx code name into NAME.  It is terminated by any of the
+   punctuation chars of rtx printed syntax.  */
+
+file_location
+read_name (struct md_name *name)
+{
+  file_location loc;
+  if (!read_name_1 (name, &loc))
+    fatal_with_file_and_line ("missing name or number");
+  return loc;
+}
+
+file_location
+read_name_or_nil (struct md_name *name)
+{
+  file_location loc;
+  if (!read_name_1 (name, &loc))
+    {
+      file_location loc = base_rtx_reader_ptr->get_current_location ();
+      read_skip_construct (0, loc);
+      /* Skip the ')'.  */
+      read_char ();
+      name->buffer[0] = 0;
+      name->string = name->buffer;
+    }
+  return loc;
 }
 
 /* Subroutine of the string readers.  Handles backslash escapes.
@@ -540,8 +576,8 @@ read_escape (void)
       /* pass anything else through, but issue a warning.  */
     default:
       fprintf (stderr, "%s:%d: warning: unrecognized escape \\%c\n",
-	       rtx_reader_ptr->get_filename (), rtx_reader_ptr->get_lineno (),
-	       c);
+	       base_rtx_reader_ptr->get_filename (),
+	       base_rtx_reader_ptr->get_lineno (), c);
       obstack_1grow (&string_obstack, '\\');
       break;
     }
@@ -584,7 +620,7 @@ read_braced_string (void)
 {
   int c;
   int brace_depth = 1;  /* caller-processed */
-  unsigned long starting_read_md_lineno = rtx_reader_ptr->get_lineno ();
+  unsigned long starting_read_md_lineno = base_rtx_reader_ptr->get_lineno ();
 
   obstack_1grow (&string_obstack, '{');
   while (brace_depth)
@@ -630,7 +666,7 @@ read_string (int star_if_braced)
       c = read_skip_spaces ();
     }
 
-  old_lineno = rtx_reader_ptr->get_lineno ();
+  old_lineno = base_rtx_reader_ptr->get_lineno ();
   if (c == '"')
     stringbuf = read_quoted_string ();
   else if (c == '{')
@@ -639,13 +675,21 @@ read_string (int star_if_braced)
 	obstack_1grow (&string_obstack, '*');
       stringbuf = read_braced_string ();
     }
+  else if (saw_paren && c == 'n')
+    {
+      /* Handle (nil) by returning NULL.  */
+      require_char ('i');
+      require_char ('l');
+      require_char_ws (')');
+      return NULL;
+    }
   else
     fatal_with_file_and_line ("expected `\"' or `{', found `%c'", c);
 
   if (saw_paren)
     require_char_ws (')');
 
-  set_md_ptr_loc (stringbuf, rtx_reader_ptr->get_filename (), old_lineno);
+  set_md_ptr_loc (stringbuf, base_rtx_reader_ptr->get_filename (), old_lineno);
   return stringbuf;
 }
 
@@ -794,8 +838,8 @@ add_constant (htab_t defs, char *name, char *value,
 /* Process a define_constants directive, starting with the optional space
    after the "define_constants".  */
 
-static void
-handle_constants (void)
+void
+base_rtx_reader::handle_constants ()
 {
   int c;
   htab_t defs;
@@ -848,8 +892,8 @@ md_decimal_string (int number)
    number on which the directive started and MD_P is true if the
    directive is a define_enum rather than a define_c_enum.  */
 
-static void
-handle_enum (file_location loc, bool md_p)
+void
+base_rtx_reader::handle_enum (file_location loc, bool md_p)
 {
   char *enum_name, *value_name;
   struct md_name name;
@@ -931,9 +975,9 @@ traverse_enum_types (htab_trav callback, void *info)
 }
 
 
-/* Constructor for rtx_reader.  */
+/* Constructor for base_rtx_reader.  */
 
-rtx_reader::rtx_reader ()
+base_rtx_reader::base_rtx_reader ()
 : m_toplevel_fname (NULL),
   m_base_dir (NULL),
   m_read_md_file (NULL),
@@ -943,12 +987,12 @@ rtx_reader::rtx_reader ()
   m_last_dir_md_include_ptr (&m_first_dir_md_include)
 {
   /* Set the global singleton pointer.  */
-  rtx_reader_ptr = this;
+  base_rtx_reader_ptr = this;
 }
 
-/* rtx_reader's destructor.  */
+/* base_rtx_reader's destructor.  */
 
-rtx_reader::~rtx_reader ()
+base_rtx_reader::~base_rtx_reader ()
 {
   free (m_base_dir);
 
@@ -972,7 +1016,7 @@ rtx_reader::~rtx_reader ()
   obstack_free (&string_obstack, NULL);
 
   /* Clear the global singleton pointer.  */
-  rtx_reader_ptr = NULL;
+  base_rtx_reader_ptr = NULL;
 }
 
 /* Process an "include" directive, starting with the optional space
@@ -981,7 +1025,7 @@ rtx_reader::~rtx_reader ()
    which the "include" occurred.  */
 
 void
-rtx_reader::handle_include (file_location loc)
+base_rtx_reader::handle_include (file_location loc)
 {
   const char *filename;
   const char *old_filename;
@@ -1057,7 +1101,7 @@ rtx_reader::handle_include (file_location loc)
    unknown directives.  */
 
 void
-rtx_reader::handle_file ()
+base_rtx_reader::handle_file ()
 {
   struct md_name directive;
   int c;
@@ -1090,7 +1134,7 @@ rtx_reader::handle_file ()
    and m_base_dir accordingly.  */
 
 void
-rtx_reader::handle_toplevel_file ()
+base_rtx_reader::handle_toplevel_file ()
 {
   const char *base;
 
@@ -1105,7 +1149,7 @@ rtx_reader::handle_toplevel_file ()
 }
 
 file_location
-rtx_reader::get_current_location () const
+base_rtx_reader::get_current_location () const
 {
   return file_location (m_read_md_filename, m_read_md_lineno);
 }
@@ -1113,7 +1157,7 @@ rtx_reader::get_current_location () const
 /* Parse a -I option with argument ARG.  */
 
 void
-rtx_reader::add_include_path (const char *arg)
+base_rtx_reader::add_include_path (const char *arg)
 {
   struct file_name_list *dirtmp;
 
@@ -1134,8 +1178,8 @@ rtx_reader::add_include_path (const char *arg)
    generic error should be reported.  */
 
 bool
-rtx_reader::read_md_files (int argc, const char **argv,
-			   bool (*parse_opt) (const char *))
+base_rtx_reader::read_md_files (int argc, const char **argv,
+				bool (*parse_opt) (const char *))
 {
   int i;
   bool no_more_options;
@@ -1244,7 +1288,7 @@ rtx_reader::read_md_files (int argc, const char **argv,
   return !have_error;
 }
 
-/* class noop_reader : public rtx_reader */
+/* class noop_reader : public base_rtx_reader */
 
 /* A dummy implementation which skips unknown directives.  */
 void
diff --git a/gcc/read-md.h b/gcc/read-md.h
index 0410875..90c4f96 100644
--- a/gcc/read-md.h
+++ b/gcc/read-md.h
@@ -21,18 +21,7 @@ along with GCC; see the file COPYING3.  If not see
 #define GCC_READ_MD_H
 
 #include "obstack.h"
-
-/* Records a position in the file.  */
-struct file_location {
-  file_location () {}
-  file_location (const char *, int);
-
-  const char *filename;
-  int lineno;
-};
-
-inline file_location::file_location (const char *filename_in, int lineno_in)
-  : filename (filename_in), lineno (lineno_in) {}
+#include "errors.h"
 
 /* Holds one symbol or number in the .md file.  */
 struct md_name {
@@ -90,11 +79,17 @@ struct enum_type {
   unsigned int num_values;
 };
 
-class rtx_reader
+/* A class for reading .md files and RTL dump files.
+   Implemented in read-md.c.
+   This class handles reading top-level directives including the
+   "include" directive.  It does not handle parsing nested directives;
+   for that see rtx_reader below (in read-rtl.c).  */
+
+class base_rtx_reader
 {
  public:
-  rtx_reader ();
-  virtual ~rtx_reader ();
+  base_rtx_reader ();
+  virtual ~base_rtx_reader ();
 
   bool read_md_files (int, const char **, bool (*) (const char *));
 
@@ -104,6 +99,9 @@ class rtx_reader
      unread character is the optional space after the directive name.  */
   virtual void handle_unknown_directive (file_location, const char *) = 0;
 
+  void handle_constants ();
+  void handle_enum (file_location loc, bool md_p);
+
   file_location get_current_location () const;
 
   int read_char (void);
@@ -151,20 +149,45 @@ class rtx_reader
   file_name_list **m_last_dir_md_include_ptr;
 };
 
-/* Global singleton.  */
-extern rtx_reader *rtx_reader_ptr;
+/* Global singleton; constrast with rtx_reader_ptr below.  */
+extern base_rtx_reader *base_rtx_reader_ptr;
 
-/* An rtx_reader subclass which skips unknown directives.  */
+/* A base_rtx_reader subclass which skips unknown directives, for
+   the gen* tools that purely use read-md.o.  */
 
-class noop_reader : public rtx_reader
+class noop_reader : public base_rtx_reader
 {
  public:
-  noop_reader () : rtx_reader () {}
+  noop_reader () : base_rtx_reader () {}
 
   /* A dummy implementation which skips unknown directives.  */
   void handle_unknown_directive (file_location, const char *);
 };
 
+/* A base_rtx_reader subclass that actually handles full rtx expressions.
+   Implemented in read-rtl.c.  */
+
+class rtx_reader : public base_rtx_reader
+{
+ public:
+  rtx_reader ();
+  ~rtx_reader ();
+
+  rtx read_rtx_code (const char *);
+  virtual rtx read_rtx_operand (rtx return_rtx, int idx);
+  rtx read_nested_rtx (void);
+  rtx read_rtx_variadic (rtx);
+
+  char *read_until (const char *terminator_chars, bool consume_terminator);
+
+  virtual void handle_any_trailing_information (rtx) {}
+
+  virtual rtx postprocess (rtx x) { return x; }
+};
+
+/* Global singleton; constrast with base_rtx_reader_ptr above.  */
+extern rtx_reader *rtx_reader_ptr;
+
 extern struct obstack string_obstack;
 extern void (*include_callback) (const char *);
 
@@ -173,7 +196,7 @@ extern void (*include_callback) (const char *);
 static inline int
 read_char (void)
 {
-  return rtx_reader_ptr->read_char ();
+  return base_rtx_reader_ptr->read_char ();
 }
 
 /* Put back CH, which was the last character read from the MD file.  */
@@ -181,7 +204,7 @@ read_char (void)
 static inline void
 unread_char (int ch)
 {
-  rtx_reader_ptr->unread_char (ch);
+  base_rtx_reader_ptr->unread_char (ch);
 }
 
 extern int peek_char (void);
@@ -204,7 +227,8 @@ extern int read_skip_spaces (void);
 extern void require_char (char expected);
 extern void require_char_ws (char expected);
 extern void require_word_ws (const char *expected);
-extern void read_name (struct md_name *);
+extern file_location read_name (struct md_name *);
+extern file_location read_name_or_nil (struct md_name *);
 extern char *read_quoted_string (void);
 extern char *read_string (int);
 extern int n_comma_elts (const char *);
